# This file is a template, and might need editing before it works on your project.
variables:
  DOCKER_IMAGE: "docker.io/hilmandroid/nginx-test"
  SERVICE_NAME: "nginx-webserver"
  EC2_INSTANCE_TYPE: "t2.micro"
  EC2_PROVISION_BASE_AMI: "ami-06e54d05255faf8f6"
  EC2_PROVISION_SECURITY_GROUP_IDS: "sg-0b29f45e56d0029fe"
  EC2_PROVISION_SUBNET_ID: "subnet-0aac389701737347d"
  EC2_PROVISION_USER: "ubuntu"
  EC2_PROVISION_SSH_KEY: "hilman"

stages:
  - build-docker
  - deploy

build-docker:
  stage: build-docker
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u $DOCKER_USERNAME -p $DOCKER_PASSWORD
    - docker build -t $DOCKER_IMAGE:$CI_COMMIT_SHA .
    - docker tag $DOCKER_IMAGE:$CI_COMMIT_SHA $DOCKER_IMAGE:latest
    - docker push $DOCKER_IMAGE:$CI_COMMIT_SHA
    - docker push $DOCKER_IMAGE:latest
    - |
      cat <<EOF > artifact.json
      {
          "docker_image": "${DOCKER_IMAGE}:${CI_COMMIT_SHA}",
          "service_name": "${SERVICE_NAME}",
          "commit": "${CI_COMMIT_SHA}"
      }
      EOF
  artifacts:
    paths:
      - artifact.json
  except:
    - master

deploy:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  script:
    - |
      cat << EOF > user-data.sh
      #!/usr/bin/env bash
      sudo apt-get update
      sudo apt-get install -y apt-transport-https ca-certificates curl gnupg-agent software-properties-common
      curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
      sudo add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu \$(lsb_release -cs) stable"
      sudo apt-get update
      sudo apt-get install -y docker-ce docker-ce-cli containerd.io
      sudo usermod -aG docker ${EC2_PROVISION_USER}
      sudo docker run -d --restart always -p 80:80 ${DOCKER_IMAGE}
      EOF
    - aws ec2 run-instances --image-id ${EC2_PROVISION_BASE_AMI} --instance-type ${EC2_INSTANCE_TYPE} --subnet-id ${EC2_PROVISION_SUBNET_ID} --user-data file://user-data.sh --key-name ${EC2_PROVISION_SSH_KEY} --security-group-ids ${EC2_PROVISION_SECURITY_GROUP_IDS}  --associate-public-ip-address | tee ec2-artifact.json
  artifacts:
    paths:
      - user-data.sh
      - ec2-artifact.json
  only:
    - master

